#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "comport.h"
#include "packet.h"                 
#include "getput.h"
#include "xgetput.h"
#include "do.h"
#include "hpkermit.h"

extern CComPort * pComPort;
int bDebug = 0;
ofstream log;
int bLogging = 0;

void DoHelp(int Mode = 0)
{
  if (Mode == 0)
  {
    cout << "Command        Description" << endl;
    cout << "--------------------------------------------------" << endl;
    cout << "A              About the program" << endl;
    cout << "B              Send break to server (abort)" << endl;
    cout << "C [directory]  Change working directory" << endl;
    cout << "D              Get listing for current directory" << endl;
    cout << "E [command]    Execute a command on the server" << endl;
    cout << "L [filename]   Begin/end logging to file" << endl;
    cout << "R [files]      Retrieve files from the server" << endl;
    cout << "S [files]      Send files to the server" << endl;
    cout << "Q              Quit the program, shutting down the server" << endl;
    cout << "ESC            Quit without shutting down the server" << endl;
    cout << "!              Toggles debugging mode on and off" << endl;
    cout << endl;
    cout << "Use /? parameter for command-line syntax help" << endl;
  }
  else if (Mode == 1)
  {
    cout << "Command        Description" << endl;
    cout << "--------------------------------------------------" << endl;
    cout << "L [filename]   Begin/end logging to file" << endl;
    cout << "R [files]      Retrieve files from the server" << endl;
    cout << "S [files]      Send files to the server" << endl;
    cout << "Q              Quit the program" << endl;
    cout << "ESC            Quit the program" << endl;
    cout << "!              Toggles debugging mode on and off" << endl;
    cout << endl;
    cout << "Use /? parameter for command-line syntax help" << endl;
  }
}

void DoCWD()
{
  char Params[256];
  cout << "Change to which directory? ";
  cin.getline(Params, 256);
  if (Params[0] == '{')
    strcat(Params, " EVAL");
  SendPacket('C', Params, 0);
  KermitGet();
}

void DoDirectory()
{
  LogMessage(LOG_EVENT, "Getting directory from HP48");
  SendPacket('G', "D", 0);
  if (KermitGet())
  {
    ifstream ins;
    ins.open("OUTPUT");
    char FileLine[512];
    ins.getline(FileLine, 512);
    unsigned int Pos = 0;
    char DirectoryName[256];
    int FreeSpace;
    for (; (Pos < strlen(FileLine) && FileLine[Pos - 1] != '}'); Pos++)
    {
      DirectoryName[Pos] = FileLine[Pos];
    }  
    DirectoryName[Pos] = '\0';
    FreeSpace = atoi(&FileLine[Pos + 1]);
    cout << "Current directory: " << DirectoryName << endl;
    LogMessage(LOG_OUTPUT, DirectoryName);
    do
    {
      char FileName[64], FileType[64];
      double Size;
      int CRC;
      ins >> FileName >> Size;
      if (ins)
        LogMessage(LOG_OUTPUT, FileName);
      ins.getline(FileLine, 512);

      unsigned int Pos = 0;
      for (; (Pos < strlen(FileLine) && !isdigit(FileLine[Pos])); Pos++)
      {
        FileType[Pos] = FileLine[Pos];
      }  
      FileType[Pos] = '\0';
      CRC = atoi(&FileLine[Pos]);
      cout.setf(ios::left);
      cout.setf(ios::fixed);
      if (ins)
      {
        cout << setw(20) << FileName 
             << setw(16) << FileType;
        cout.setf(ios::right);
        cout << setw(10) << setprecision(1) << Size
             << setw(6) << CRC << endl;
      }
    }
    while (ins);
    cout << FreeSpace << " free bytes" << endl;
  }
  else
  {
    cout << "Error: Command failed" << endl;
  }
}

void DoCommand()
{
  char Params[256] = "";
  cout << "Command mode (hit ~ and ENTER to quit)" << endl;
  LogMessage(LOG_EVENT, "Entered command mode");
  int bQuit = 0;
  while (!bQuit)
  {
    if (Params[0] == '~' && strlen(Params) == 1)
    {
      bQuit = 1;
    }
    else
    {
      LogMessage(LOG_MESSAGE, Params);
      SendPacket('C', Params, 0);
      if (KermitGet(0))
      {
        ifstream ins;
        ins.open("OUTPUT");
        while (ins)
        {
          char Output[512];
          ins.getline(Output, 512);
          if (ins)
          {
            LogMessage(LOG_OUTPUT, Output);
            cout << Output << endl;
          }
        }
      }
      else
      {
        cout << "Error: Command failed" << endl;
      }
    }
    while (kbhit())
      getch();
    if (!bQuit)
    {
      cout << "HP> ";
      cin.getline(Params, 256);
    }
  }
  LogMessage(LOG_EVENT, "Exited command mode");
}

void DoReceive()
{
  LogMessage(LOG_EVENT, "Get file from server");
  char Filename[128];
  cout << "Receive which file? ";
  cin.getline(Filename, 128);
  LogMessage(LOG_MESSAGE, Filename);
  if (strlen(Filename) > 0)
  {
    SendPacket('R', Filename, 0);
    KermitGet();
  }
}

void DoSend()
{
  LogMessage(LOG_EVENT, "Send file to server");
  char Filename[128];
  cout << "Send which file? ";
  cin.getline(Filename, 128);
  LogMessage(LOG_MESSAGE, Filename);
  for (unsigned int i = 0; i < strlen(Filename); i++)
    Filename[i] = toupper(Filename[i]);
  if (strlen(Filename) > 0)
    KermitPut(Filename);
}

void DoXReceive()
{
  LogMessage(LOG_EVENT, "Get file from server");
  char Filename[128];
  cout << "Receive which file? ";
  cin.getline(Filename, 128);
  LogMessage(LOG_MESSAGE, Filename);
  if (strlen(Filename) > 0)
    XmodemGet(Filename);
}

void DoXSend()
{
  LogMessage(LOG_EVENT, "Send file to server");
  char Filename[128];
  cout << "Send which file? ";
  cin.getline(Filename, 128);
  LogMessage(LOG_MESSAGE, Filename);
  for (unsigned int i = 0; i < strlen(Filename); i++)
    Filename[i] = toupper(Filename[i]);
  if (strlen(Filename) > 0)
    XmodemPut(Filename);
}

void DoToggleDebug()
{
  bDebug = 1 - bDebug;
  cout << "Debugging mode ";
  if (bDebug)
    cout << "ON";
  else 
    cout << "OFF";
  cout << endl;
}

void DoShutdown()
{
  cout << "Shutting down server" << endl;
  SendPacket('G', "F", 0);
}

void DoBreak()
{
  LogMessage(LOG_EVENT, "Sent break packet");
  cout << "Sending break packet" << endl;
  SendPacket('E', "Abort#M#J", 0);
}

void DoAbout(int bFullVersion = 0)
{
  cout << "HP-Kermit: HP48 Kermit Interface v" << Version << "." 
       << SubVersion << "." << VersionType << " (" << System << ")" << endl;
  cout << "Copyright 1997 by Matthew Mastracci" << endl;
  if (strlen(PortBy) > 0)
    cout << System << " port by " << PortBy << endl;
  cout << "Use /? parameter for command-line syntax help" << endl;
  if (!bFullVersion)
  {
    cout << endl;
  }
  else
  {
    cout << "--------------------------------------------------" << endl;
    cout << "This program is free software and, as such, you may distributed it freely," << endl;
    cout << "as long as no modifications are made to the original archive." << endl;
    cout << endl;
    cout << "More than 16 straight hours went into the original creation and testing of" << endl;
    cout << "this program, so I hope you find some good use of it.  ;)  At some time in" << endl; 
    cout << "the future (when most of the bugs are out) I'll release the source code." << endl;
    cout << endl;
    cout << "You can contact me at: mmastrac@acs.ucalgary.ca" << endl;
    cout << "or visit my web page at: http://www.ucalgary.ca/~mmastrac" << endl;
    cout << endl;
    cout << "Thanks for using HP-Kermit!" << endl;
    cout << "                           - Matthew Mastracci 9/11/97" << endl;
    cout << "--------------------------------------------------" << endl;
    cout << "Using COM" << pComPort->Port() << ", 9600 baud (N,8,1)" << endl;
    cout << "Settings:  base: " << hex << pComPort->m_nBasePort << " IRQ: " << hex << pComPort->m_nIRQ << " interrupt: " << hex << pComPort->m_nInterrupt << endl;
    cout << dec;
  }
}

void DoEasterEgg()
{
  static int bFound = 0;
  if (!bFound)
  {
    cout << "Thanks goodness you found me!  I was beginning to get so lonely..." << endl;
    bFound = 1;
  }
  else
  {
    cout << "Error: Unrecognized command" << endl;
  }
}

void DoTest()
{
  char c;
  cout << "I am now beginning the HP<->PC link test.  Hit ESC at any point to abort." << endl;
  cout << endl;
  cout << "I will proceed to output a string to the calculator.  Before the test begins," << endl;
  cout << "use the OPENIO command to open the serial port.  During the test, use the" << endl;
  cout << "BUFLEN command to ensure the proper number of characters were received and" << endl; 
  cout << "then DROP and SRECV to check the contents." << endl;
  cout << endl;
  cout << "Using COM" << pComPort->Port() << ", 9600 baud (N,8,1)" << endl;
  cout << "Settings:  base: " << hex << pComPort->m_nBasePort << " IRQ: " << hex << pComPort->m_nIRQ << " interrupt: " << hex << pComPort->m_nInterrupt << endl;
  cout << dec;
  cout << "Hit any key to proceed..." << flush;
  c = getch();
  if (c == 27) 
    return;
  cout << endl << "Sending simple char:" << endl;
  cout << "BUFLEN = 1, SRECV = \"A\"" << endl;
  pComPort->WriteData("A");
  cout << "Hit any key to proceed..." << flush;
  c = getch();
  if (c == 27) 
    return;
  cout << endl << "Sending alphabet blast:" << endl;
  cout << "BUFLEN = 26, SRECV = \"ABCDEFGHIJKLMNOPQRSTUVWXYZ\"" << endl;
  for (int i = 'A'; i <= 'Z'; i++) 
  {
    char c = i;
    pComPort->WriteData(&c);
  }
  cout << "Hit any key to proceed..." << flush;
  c = getch();
  if (c == 27) 
    return;
  cout << endl << "Sending typical packet:" << endl;
  cout << "BUFLEN = 20, SRECV = <packet data>" << endl;
  SendPacket('E', "Interrupted#M#J", 12);
  cout << "Hit any key to proceed..." << flush;
  c = getch();
  if (c == 27) 
    return;
  cout << endl << "Done!" << endl;
}

void DoLog()
{
  if (bLogging)
  {
    LogMessage(LOG_EVENT, "Stopped logging");
    bLogging = 0;
    cout << "Logging OFF" << endl;
    log.close();
  }
  else
  {
    cout << "Enter the log file to append/create: ";
    char c[64];
    cin >> c;
    if (strlen(c) > 0)
    {
      log.open(c, ios::app);
      bLogging = 1;
      LogMessage(LOG_EVENT, "Started logging");
    }
    else
    {
      cout << "Logging cancelled" << endl;
    }
  }
}

void DoConfigure()
{
  int ComPort, BasePort = 0, IRQ = 0, Interrupt = 0;
  cout << "Starting program configuration (hit Ctrl-C to quit)" << endl << endl;
  cout << "Enter the preset communications port you wish to use (type 0 for custom" << endl;
  cout << "port configurations): " << endl;
  cin >> ComPort;
  if (ComPort == 0)
  {
    cout << "Enter the base port of your communication port in hex (ie: 3f8): ";
    cin >> hex >> BasePort;
    cout << "Enter the IRQ for your communication port (ie: 3 or 4): ";
    cin >> hex >> IRQ;
    cout << "Enter the interrupt number for your communication port (ie: 0c): ";
    cin >> hex >> Interrupt;
    cout << "Writing KERMIT.CFG with parameters:" << endl;
    cout << "  Base port: " << hex << BasePort << "h" << endl;
    cout << "  IRQ: 0" << hex << IRQ << "h" << endl;
    cout << "  Interrupt: 0" << hex << Interrupt << "h" << endl;
  }
  else
  {
    cout << "Writing KERMIT.CFG with COM" << ComPort << endl;
  }
  cout << dec;
  cin >> dec;
  ofstream outs;
  outs.open("KERMIT.CFG");
  outs << ComPort << " " << hex << BasePort << " " << hex << IRQ << " " 
       << hex << Interrupt;
  outs.close();
}

int DoReadConfiguration()
{
  ifstream ins;
  ins.open("kermit.cfg");
  int COMPort = 1, BasePort = 0x3f8, IRQ = 3, Interrupt = 0x0c;
  if (ins)
  {
    ins >> COMPort >> hex >> BasePort >> hex >> IRQ >> hex >> Interrupt;
  }
  else
  {
    cout << "I have detected that this is your first time using HP-Kermit (or your" << endl;
    cout << "configuration file has been erased).  Please read the documentation" << endl;
    cout << "for hints on all the things your can do with this program (like backing" << endl;
    cout << "up your HP to your PC, sending with Xmodem instead of Kermit, etc.)." << endl;
    cout << endl;
    DoConfigure();
    return 0;
  }
  if (!ins)
  {
    cout << "Problem encountered while reading KERMIT.CFG" << endl;
    DoConfigure();
    return 0;
  }
  ins.close();
  
  CComPort * pCOM = new CComPort(COMPort, BasePort, IRQ, Interrupt);
  pCOM->Flush();  

  return 1;
}

void DoCleanUp()
{
  delete pComPort;
}

void LogMessage(char Type, const char * Message)
{
  if (bLogging)
  {
    if (Type == LOG_BLANK)
      log << endl;
    else
    {
      unsigned int t = time(NULL);
      char * pTime = asctime(localtime(&t));
      pTime[24] = '\0';
      log << Type << " [" << pTime << "] " << Message << endl;
    }
  }
}


