#include <ctype.h>
#include <conio.h>
#include <iostream.h>
#include "do.h"

#ifdef i386
#include <crt0.h>
int CRT0_STARTUP_FLAGS = _CRT0_FLAG_LOCK_MEMORY;
#endif

extern int bLogging;

int main(int argc, char ** argv)
{
  DoAbout();

  if (!DoReadConfiguration())
    return 0;

  int Xmodem = 0;  

  if (argc == 2 && toupper(argv[1][1]) == 'T')
  {
    DoTest();
    return 0;
  } 
  else if (argc == 2 && toupper(argv[1][1]) == 'C')
  {
    DoConfigure();
    return 0;
  } 
  else if (argc == 2 && toupper(argv[1][1]) == 'X')
  {
    cout << "Starting in Xmodem Transfer mode..." << endl;
    Xmodem = 1;
  } 
  else if (argc == 2)
  {
    if (toupper(argv[1][1]) != '?')
      cout << "Invalid parameter: " << toupper(argv[1][1]) << endl;
    cout << "Usage: HPKERMIT [/T | /C | /X | /?]" << endl;
    cout << "Where: /T initiates HP<->PC link test mode" << endl;
    cout << "       /C initiates program configuration" << endl;
    cout << "       /X initiates Xmodem transfer mode" << endl;
    cout << endl;
    cout << "Running HPKERMIT with no parameters will start the program up" << endl; 
    cout << "in kermit interactive mode." << endl;
    return 0;
  }
  else
  {
    cout << "Starting in Kermit Interactive mode..." << endl;
  }
  
  int bQuit = 0;
  while (!bQuit)
  {
    if (wherex() != 1)
      cout << endl;
    while (kbhit())
      getch();
    cout << "(? for help)> " << flush;
    char Command = toupper(getch());
    if (Command == 27)
      cout << "ESC" << endl;
    else
      cout << Command << endl;
    if (!Xmodem)
    {
      switch (toupper(Command))
      {
      case 0 : getch(); break;
      case '?' : DoHelp(); break;
      case '!' : DoToggleDebug(); break;
      case 'A' : DoAbout(1); break;
      case 'B' : DoBreak(); break;
      case 'C' : DoCWD(); break;
      case 'D' : DoDirectory(); break;
      case 'E' : DoCommand(); break;
      case 'L' : DoLog(); break;
      case 'Q' : DoShutdown(); 
      case 27  : bQuit = 1; break;
      case 'R' : DoReceive(); break;
      case 'S' : DoSend(); break;
      case 'Z' : DoEasterEgg(); break;
      default : cout << "Error: Unrecognized command" << endl;
      }
    }
    else
    {
      switch (toupper(Command))
      {
      case 0 : getch(); break;
      case '?' : DoHelp(1); break;
      case '!' : DoToggleDebug(); break;
      case 'L' : DoLog(); break;
      case 27  : 
      case 'Q' : bQuit = 1; break;
      case 'R' : DoXReceive(); break;
      case 'S' : DoXSend(); break;
      default : cout << "Error: Unrecognized command" << endl;
      }
    }
  }
  LogMessage(LOG_EVENT, "Program ended");
  LogMessage(LOG_BLANK, "");
  cout << "Done!" << endl;

  DoCleanUp();

  return 0;
}
