#ifndef _PACKET_H_
#define _PACKET_H_

#define tochar(x) (x + 32)
#define unchar(x) (x - 32) 
#define ctl(x) (x ^ 64)

struct Packet
{
  int Length;
  int Sequence;
  char Type;
  char Data[256];
  int Check, CalcCheck;
};

void ACKPacket(int PacketNum);
void NAKPacket(int PacketNum);
void Escape(char * Data, int * Size);
void Unescape(char * Data, int * Size);
void CRLFToCR(char * Data, int * Size);
void ResetEscape();
int HitEscape();
int GetChar(char * c);
int CalcPacketChecksum1(Packet * pPacket);
void PrintPacket(Packet * pPacket);
void SendPacket(Packet * pPacket);
void SendPacket(char Type, const char * Data, int SequenceNum);
int GetPacket(Packet * pPacket);

#endif
